# **************************************************
#
#  The class containing the constants
#
# **************************************************

class _const:
   
    class ConstError(TypeError): pass
    
    def __setattr__(self, name, value):
        if self.__dict__.has_key(name):
            raise self.ConstError, "Can't rebind const(%s)" % name
        self.__dict__[name] = value
        
    def __delattr__(self, name):
        if self.__dict__.has_key(name):
            raise self.ConstError, "Can't unbind const(%s)" % name
        raise NameError, name

    # Kraken RDF entry
    KRAKEN_RDF_URI = "http://www.cs.ucf.edu/~lboloni/Programming/KrakenWeb/krakenEntrySchema/"

    # Filename and Directory names
    KRAKEN_DIR_INDICATOR_FILE = "KRAKEN"
    SYSTEM_FILE = "~/.krakenrc.rdf"
    METADATA_FILE = "~/.kraken_metadata"
    METADATA_RDF_FILE = "~/.kraken_metadata.rdf"
    DIRECTORY_PREFIX = "kra"
    DIRNAME_METADATA = "Metadata"
    FILENAME_ENTRY_RDF = "entry2.rdf"
    FILENAME_ENTRY_RDF_OLD = "entry.rdf"    
    
    # Default file and directory names (changeable)
    DEFAULT_HTML_FILE = "kraken.html"
    DEFAULT_CSS_FILE = "kraken.css"
    DEFAULT_CSS_FILENAME = "kraken.css"
    DEFAULT_STAGING_DIR = "~/.kraken/staging/"
    DEFAULT_DESTINATION_DIR = "~/.kraken/kraken/"
    DEFAULT_FILTER_DIR = "~/.kraken/filters/"
    DEFAULT_LINK_DIR = "~/.kraken/links/"
    DEFAULT_GENERATED_ENTRY_DIR = "~/.kraken/generated/"
    DEFAULT_HTML_DIR = "~/.kraken/html/"
    
    HTML_DATE_FORMAT = "%a, %d %b %Y %H:%M:%S"
    
    # Commands - FIXME: these should be configuration items
    COMMAND_DOWNLOAD_SINGLE_FILE = "wget "
    COMMAND_DOWNLOAD_FULLPAGE = "wget -p "
    COMMAND_VIEW_IMAGE = "iview"
    COMMAND_VIEW_HTML = "mozilla"
    COMMAND_VIEW_TEXT = "jedit"
    
    # Extensions of kraken files
    EXTENSION_FILTER = ".flt"
    EXTENSION_SORTER = ".srtr"
    EXTENSION_QUERY  = ".qry"
    
    # Time format
    FORMAT_TIME = "%a, %d %b %Y %H:%M:%S +0000"
    
    
import sys
sys.modules[__name__] = _const()        
    

